Subject: Two Different Routes to the Same Node, One with Via

From: Koushik Roy <[email-masked]>
Date: Thu, 09 Dec 2021 20:13:13 -0800

Hey,

I'm in a situation where I have two different routes to the same node,
but in one case the node is not directly accessible and the other case
it is.

The case is simple. I have a box Foo, a box Bar, and a relay box Baz
which has a WAN routable IP.  Foo is a laptop and I usually am home with
it, and Foo is on my LAN. Bar is a stationary box that sits on my
LAN. Bar is not accessible through a WAN. Normally Foo can directly
access Bar via the LAN. However, when I travel with Foo, Foo cannot talk
to Bar directly. Instead I use the relay host Baz; Foo sends a packet to
Baz and then Baz relays the packet to Foo.

Right now it doesn't seem possible to have two different paths when one
includes a "via" block. In the meantime, I always use Baz as a relay,
even when Foo and Bar can talk to each other over the LAN because it
simplifies configuration and I'm not in a rush for NNCP packets to make
it from Foo to Bar. Would it be possible to add support for
distinguishing between a direct connection to a neighbor node and a
relay connection to the node? Also, I could make an attempt at modifying the
source myself and submit a patch if you are open to it.

Thanks,
Koushik